#include "LinePlotWin.h"
#include <math.h>
#include <string.h>
#include <sgl/transform3.h>
#include "jed.h"
#include <stdio.h>

LinePlotWin::LinePlotWin()
{
  strcpy(title,"foreach i (COLUMNS) {plot(MAX(i))}");
}

LinePlotWin::~LinePlotWin()
{
}

void LinePlotWin::display()
{
  // Make sure a valid dataImage exists
  if (dataImage.pixels==NULL)
    return;

  // Figure step size
  int step = selectionsize / sqrt(maxPointsToSample);
  if (step <1 ) step =1;

  // counting arrays
  int rhist[4096], ghist[4096], bhist[4096];
  for (int i=0;i<4097;++i)
    {
      rhist[i]=ghist[i]=bhist[i]=0;
    }

  // Sample the image
  for (int x=xselection-selectionsize; x< xselection+selectionsize; x+=step)
    {
    for (int y=yselection-selectionsize; y< yselection+selectionsize; y+=step)
      {
	Vector3     rgb;
	//int rval = rgb.x=dataImage.r(x,y);
	//	rgb.y=dataImage.g(x,y);
	//	rgb.z=dataImage.b(x,y);

	//cout << "histrgb " << rgb << "\n";

	//	printf ("rval [%d %d %d] ",x,y,rval);
	rhist[x] =MAX(rhist[x],dataImage.r(x,y));
	ghist[x] =MAX(ghist[x],dataImage.g(x,y));
	bhist[x] =MAX(bhist[x],dataImage.b(x,y));
      }
    // Fill in skipped columns
    for (int xf=0;xf<step;xf++)
      {
	rhist[x+xf]=rhist[x];
	ghist[x+xf]=ghist[x];
	bhist[x+xf]=bhist[x];
      }
    }

  glClearColor(0,0,0,1);
  glClear(GL_COLOR_BUFFER_BIT);

  displayTitle();
  
  int maxHistValue=256;
  double maxHistMult = (double)height/(double)maxHistValue;

  for (i=0; i<width; i++)
    {
       int offset = xselection-selectionsize;
       int x=offset+(i)*selectionsize*2/width;
       int xd=offset+(i+1)*selectionsize*2/width;
      //int xd = x+step;
      
      // RED
      glColor3f(1,0,0);
      glBegin(GL_LINES);
      glVertex2s(i  ,(double)rhist[x]*maxHistMult);
      glVertex2s(i+1,(double)rhist[xd]*maxHistMult);
      glEnd();
      // GREEN
      glColor3f(0,1,0);
      glBegin(GL_LINES);
      glVertex2s(i  ,(double)ghist[x]*maxHistMult);
      glVertex2s(i+1,(double)ghist[xd]*maxHistMult);
      glEnd();
      // BLUE
      glColor3f(0,0,1);
      glBegin(GL_LINES);
      glVertex2s(i  ,(double)bhist[x]*maxHistMult);
      glVertex2s(i+1,(double)bhist[xd]*maxHistMult);
      glEnd();

      
    }
  
}



